Index: devfs_devs.c
===================================================================
RCS file: /home/ncvs/src/sys/fs/devfs/devfs_devs.c,v
retrieving revision 1.19
diff -u -r1.19 devfs_devs.c
--- devfs_devs.c	9 Jan 2002 04:58:45 -0000	1.19
+++ devfs_devs.c	26 Feb 2002 17:29:56 -0000
@@ -80,6 +80,7 @@
 		return (&devfs_refoverflow[inode - NDEVFSINO]);
 	else
 		panic ("YRK!");
+	return (NULL);
 }
 
 static void
Index: fifo_vnops.c
===================================================================
RCS file: /home/ncvs/src/sys/fs/fifofs/fifo_vnops.c,v
retrieving revision 1.62
diff -u -r1.62 fifo_vnops.c
--- fifo_vnops.c	14 Jan 2002 22:03:48 -0000	1.62
+++ fifo_vnops.c	26 Feb 2002 17:30:30 -0000
@@ -620,4 +620,5 @@
 
 	panic("fifo_badop called");
 	/* NOTREACHED */
+	return (0);
 }
Index: dsp.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/sound/pcm/dsp.c,v
retrieving revision 1.54
diff -u -r1.54 dsp.c
--- dsp.c	25 Jan 2002 04:14:12 -0000	1.54
+++ dsp.c	26 Feb 2002 17:28:30 -0000
@@ -174,7 +174,7 @@
 	struct pcm_channel *rdch, *wrch;
 	struct snddev_info *d;
 	intrmask_t s;
-	u_int32_t fmt;
+	u_int32_t fmt = 0;
 	int devtype;
 
 	s = spltty();
Index: kern_intr.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_intr.c,v
retrieving revision 1.69
diff -u -r1.69 kern_intr.c
--- kern_intr.c	11 Feb 2002 23:56:18 -0000	1.69
+++ kern_intr.c	26 Feb 2002 17:33:44 -0000
@@ -73,7 +73,7 @@
 u_char
 ithread_priority(enum intr_type flags)
 {
-	u_char pri;
+	u_char pri = 0;
 
 	flags &= (INTR_TYPE_TTY | INTR_TYPE_BIO | INTR_TYPE_NET |
 	    INTR_TYPE_CAM | INTR_TYPE_MISC | INTR_TYPE_CLK | INTR_TYPE_AV);
Index: subr_bus.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/subr_bus.c,v
retrieving revision 1.99
diff -u -r1.99 subr_bus.c
--- subr_bus.c	26 Feb 2002 10:38:33 -0000	1.99
+++ subr_bus.c	26 Feb 2002 17:35:24 -0000
@@ -1704,6 +1704,7 @@
 	 * If an interrupt mapping gets to here something bad has happened.
 	 */
 	panic("root_setup_intr");
+	return (0);
 }
 
 static kobj_method_t root_methods[] = {
Index: uipc_usrreq.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/uipc_usrreq.c,v
retrieving revision 1.81
diff -u -r1.81 uipc_usrreq.c
--- uipc_usrreq.c	25 Feb 2002 00:03:34 -0000	1.81
+++ uipc_usrreq.c	26 Feb 2002 17:37:09 -0000
@@ -511,7 +511,7 @@
 	struct socket *so;
 {
 	register struct unpcb *unp;
-	int error;
+	int error = 0;
 
 	if (so->so_snd.sb_hiwat == 0 || so->so_rcv.sb_hiwat == 0) {
 		switch (so->so_type) {
Index: vfs_default.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/vfs_default.c,v
retrieving revision 1.56
diff -u -r1.56 vfs_default.c
--- vfs_default.c	23 Oct 2001 01:23:41 -0000	1.56
+++ vfs_default.c	26 Feb 2002 17:38:32 -0000
@@ -159,6 +159,7 @@
 {
 
 	panic("filesystem goof: vop_panic[%s]", ap->a_desc->vdesc_name);
+	return (0);
 }
 
 static int
@@ -364,7 +365,7 @@
 	 * to be handled in intermediate layers.
 	 */
 	struct vnode *vp = ap->a_vp;
-	int vnflags, flags = ap->a_flags;
+	int vnflags = 0, flags = ap->a_flags;
 
 	switch (flags & LK_TYPE_MASK) {
 	case LK_DRAIN:
Index: ffs_alloc.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ffs/ffs_alloc.c,v
retrieving revision 1.87
diff -u -r1.87 ffs_alloc.c
--- ffs_alloc.c	7 Feb 2002 22:13:56 -0000	1.87
+++ ffs_alloc.c	26 Feb 2002 17:41:48 -0000
@@ -191,6 +191,7 @@
 	ufs_daddr_t bprev, bno;
 
 	*bpp = 0;
+	request = 0;
 	vp = ITOV(ip);
 	fs = ip->i_fs;
 #ifdef DIAGNOSTIC
Index: ffs_softdep.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ffs/ffs_softdep.c,v
retrieving revision 1.107
diff -u -r1.107 ffs_softdep.c
--- ffs_softdep.c	7 Feb 2002 00:54:32 -0000	1.107
+++ ffs_softdep.c	26 Feb 2002 17:44:42 -0000
@@ -312,7 +312,7 @@
 	int timo;
 {
 	struct thread *holder;
-	int s, retval;
+	int s, retval = 0;
 
 	s = lk->lkt_spl;
 #	ifdef DEBUG
@@ -2311,7 +2311,7 @@
 	ufs_daddr_t nb;
 	struct fs *fs;
 	struct worklist *wk;
-	struct indirdep *indirdep;
+	struct indirdep *indirdep = NULL;
 	int i, lbnadd, nblocks;
 	int error, allerror = 0;
 
Index: elf_machdep.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/i386/elf_machdep.c,v
retrieving revision 1.8
diff -u -r1.8 elf_machdep.c
--- elf_machdep.c	21 Dec 1999 11:14:02 -0000	1.8
+++ elf_machdep.c	26 Feb 2002 17:53:27 -0000
@@ -35,10 +35,10 @@
 elf_reloc(linker_file_t lf, const void *data, int type, const char *sym)
 {
 	Elf_Addr relocbase = (Elf_Addr) lf->address;
-	Elf_Addr *where;
+	Elf_Addr *where = NULL;
 	Elf_Addr addr;
-	Elf_Addr addend;
-	Elf_Word rtype;
+	Elf_Addr addend = NULL;
+	Elf_Word rtype = NULL;
 	const Elf_Rel *rel;
 	const Elf_Rela *rela;
 
Index: vm86.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/i386/vm86.c,v
retrieving revision 1.43
diff -u -r1.43 vm86.c
--- vm86.c	17 Nov 2001 01:38:31 -0000	1.43
+++ vm86.c	26 Feb 2002 17:54:27 -0000
@@ -500,6 +500,7 @@
 	return (kva);
 bad:
 	panic("vm86_addpage: not enough room, or overlap");
+	return (NULL);
 }
 
 static void
Index: dead_vnops.c
===================================================================
RCS file: /home/ncvs/src/sys/fs/deadfs/dead_vnops.c,v
retrieving revision 1.31
diff -u -r1.31 dead_vnops.c
--- dead_vnops.c	1 May 2001 08:13:06 -0000	1.31
+++ dead_vnops.c	26 Feb 2002 17:29:27 -0000
@@ -262,6 +262,7 @@
 
 	panic("dead_badop called");
 	/* NOTREACHED */
+	return (0);
 }
 
 /*